import * as tslib_1 from "tslib";
import "./Badge.css";
import * as React from "react";
import { BaseFluxComponent } from "../Utilities/BaseFluxComponent";
import { Callout } from "OfficeFabric/Callout";
import { Label } from "OfficeFabric/Label";
import { css } from "OfficeFabric/Utilities";
import { VssIcon } from "VSSUI/VssIcon";
var Badge = (function (_super) {
    tslib_1.__extends(Badge, _super);
    function Badge() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onMouseOver = function () {
            if (_this.props.showCalloutOnHover) {
                _this.setState({
                    isCalloutVisible: true
                });
            }
        };
        _this._onMouseOut = function () {
            if (_this.props.showCalloutOnHover) {
                _this._dismissCallout();
            }
        };
        _this._onClickCallout = function () {
            if (!_this.props.showCalloutOnHover) {
                _this.setState({
                    isCalloutVisible: !_this.state.isCalloutVisible
                });
            }
        };
        _this._dismissCallout = function () {
            _this.setState({
                isCalloutVisible: false
            });
        };
        return _this;
    }
    Badge.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { className: css("badge", this.props.className) },
            React.createElement("div", { className: "badge-container", onMouseEnter: this._onMouseOver, onMouseLeave: this._onMouseOut, onClick: this._onClickCallout },
                React.createElement("div", { ref: function (element) { return _this._calloutTargetElement = element; } },
                    React.createElement(VssIcon, { iconType: 0, iconName: "Ringer", className: "badge-icon" })),
                React.createElement(Label, { className: "badge-notification-count" }, this.props.notificationCount)),
            this.state.isCalloutVisible &&
                React.createElement(Callout, { gapSpace: 0, target: this._calloutTargetElement, onDismiss: this._dismissCallout, setInitialFocus: true, isBeakVisible: true, directionalHint: this.props.directionalHint || 6 },
                    React.createElement("div", { className: "badge-callout-container" }, this.props.children))));
    };
    Badge.prototype.initializeState = function () {
        this.state = {
            isCalloutVisible: false
        };
    };
    return Badge;
}(BaseFluxComponent));
export { Badge };
//# sourceMappingURL=Badge.js.map