import * as tslib_1 from "tslib";
import "./ColorPicker.css";
import * as React from "react";
import { stringEquals } from "../../Utilities/String";
import { InfoLabel } from "../InfoLabel";
import { BaseFluxComponent } from "../Utilities/BaseFluxComponent";
import { AccessibilityColor } from "./Color";
import { DefaultButton } from "OfficeFabric/Button";
import { Callout } from "OfficeFabric/Callout";
import { autobind, css } from "OfficeFabric/Utilities";
var ColorPicker = (function (_super) {
    tslib_1.__extends(ColorPicker, _super);
    function ColorPicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ColorPicker.prototype.componentWillReceiveProps = function (nextProps, context) {
        _super.prototype.componentWillReceiveProps.call(this, nextProps, context);
        if (!stringEquals(nextProps.selectedColor, this.state.selectedColor, true)) {
            this.setState({ selectedColor: nextProps.selectedColor || "#FFFFFF" });
        }
    };
    ColorPicker.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { className: css("color-picker", this.props.className) },
            this.props.label && React.createElement(InfoLabel, { className: "color-picker-label", label: this.props.label, info: this.props.info }),
            React.createElement("div", { className: "selected-color-container", ref: function (target) { return _this._targetElement = target; } },
                React.createElement("div", { className: "selected-color", style: { backgroundColor: this.state.selectedColor }, onClick: this._toggleCallout }),
                React.createElement(DefaultButton, { className: "open-callout-button", iconProps: { iconName: "ChevronDown" }, onClick: this._toggleCallout })),
            this.state.isCalloutOpen &&
                React.createElement(Callout, { className: "colors-callout", isBeakVisible: false, onDismiss: this._onCalloutDismiss, setInitialFocus: true, target: this._targetElement },
                    React.createElement("ul", { className: "colors-list" }, AccessibilityColor.FullPaletteColors.map(this._renderColorItem)))));
    };
    ColorPicker.prototype.initializeState = function () {
        this.state = {
            selectedColor: this.props.selectedColor || "#FFFFFF",
            isCalloutOpen: false
        };
    };
    ColorPicker.prototype._renderColorItem = function (color, index) {
        var _this = this;
        var isSelected = stringEquals(this.state.selectedColor, color.asHex(), true);
        var onSelectColor = function () { return _this._selectColor(color.asHex()); };
        return (React.createElement("li", { key: index, className: isSelected ? "color-list-item selected" : "color-list-item", onClick: onSelectColor, style: { backgroundColor: color.asRgb() } }, isSelected && React.createElement("div", { className: "inner" })));
    };
    ColorPicker.prototype._selectColor = function (color) {
        this.setState({ selectedColor: color, isCalloutOpen: false });
        this.props.onChange(color);
    };
    ColorPicker.prototype._toggleCallout = function () {
        this.setState({ isCalloutOpen: !this.state.isCalloutOpen });
    };
    ColorPicker.prototype._onCalloutDismiss = function () {
        this.setState({ isCalloutOpen: false });
    };
    tslib_1.__decorate([
        autobind
    ], ColorPicker.prototype, "_renderColorItem", null);
    tslib_1.__decorate([
        autobind
    ], ColorPicker.prototype, "_toggleCallout", null);
    tslib_1.__decorate([
        autobind
    ], ColorPicker.prototype, "_onCalloutDismiss", null);
    return ColorPicker;
}(BaseFluxComponent));
export { ColorPicker };
//# sourceMappingURL=ColorPicker.js.map