import * as React from "react";
import { parseUniquefiedIdentityName, parseWorkItemIdentityName } from "../../Utilities/Identity";
import { Persona, PersonaSize } from "OfficeFabric/Persona";
import { css } from "OfficeFabric/Utilities";
export var IdentityView = function (props) {
    var identityDistinctName = props.identityDistinctName, useWorkItemIdentityParser = props.useWorkItemIdentityParser;
    var identityRef = props.identityRef;
    if (!identityRef) {
        identityRef = useWorkItemIdentityParser ? parseWorkItemIdentityName(identityDistinctName) : parseUniquefiedIdentityName(identityDistinctName);
    }
    if (!identityRef || !identityRef.displayName) {
        return null;
    }
    return (React.createElement(Persona, { className: css("identity-view", props.className), size: props.size || PersonaSize.extraExtraSmall, imageUrl: identityRef.imageUrl, primaryText: identityRef.displayName, secondaryText: identityRef.uniqueName }));
};
//# sourceMappingURL=IdentityView.js.map