/// <reference types="react" />
import "./RichEditor.css";
import "trumbowyg/dist/ui/trumbowyg.min.css";
import "trumbowyg/dist/trumbowyg";
import "../../Utilities/PasteImagePlugin";
import "../../Utilities/UploadImagePlugin";
import { IFocussable } from "../Interfaces";
import { BaseFluxComponent, IBaseFluxComponentProps, IBaseFluxComponentState } from "../Utilities/BaseFluxComponent";
export interface IRichEditorProps extends IBaseFluxComponentProps {
    containerId?: string;
    value?: string;
    delay?: number;
    editorOptions?: any;
    label?: string;
    info?: string;
    error?: string;
    disabled?: boolean;
    required?: boolean;
    onChange(newValue: string): void;
    getPastedImageUrl?(value: string): Promise<string>;
}
export interface IRichEditorState extends IBaseFluxComponentState {
    value?: string;
}
export declare class RichEditor extends BaseFluxComponent<IRichEditorProps, IRichEditorState> implements IFocussable {
    private _richEditorContainer;
    private _containerId;
    private _delayedFunction;
    focus(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentWillReceiveProps(nextProps: IRichEditorProps, context?: any): void;
    render(): JSX.Element;
    protected initializeState(): void;
    private _getDefaultError();
    private _onChange();
    private _fireChange();
    private _onImagePaste(args);
    private _disposeDelayedFunction();
}
