import * as tslib_1 from "tslib";
import { throttledDelegate } from "../../Utilities/Core";
import { BaseFluxComponent } from "./BaseFluxComponent";
var AutoResizableComponent = (function (_super) {
    tslib_1.__extends(AutoResizableComponent, _super);
    function AutoResizableComponent(props, context) {
        var _this = _super.call(this, props, context) || this;
        _this._bodyElement = document.getElementsByTagName("body").item(0);
        _this._windowResizeThrottleDelegate = throttledDelegate(_this, 50, function () {
            _this._windowWidth = window.innerWidth;
            _this.resize();
        });
        _this._windowWidth = window.innerWidth;
        $(window).resize(function () {
            if (Math.abs(_this._windowWidth - window.innerWidth) > AutoResizableComponent.WIDTH_DELTA) {
                _this._windowResizeThrottleDelegate.call(_this);
            }
        });
        return _this;
    }
    AutoResizableComponent.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this.resize();
    };
    AutoResizableComponent.prototype.componentDidUpdate = function () {
        this.resize();
    };
    AutoResizableComponent.prototype.resize = function () {
        VSS.resize(null, this._bodyElement.offsetHeight);
    };
    AutoResizableComponent.WIDTH_DELTA = 10;
    return AutoResizableComponent;
}(BaseFluxComponent));
export { AutoResizableComponent };
//# sourceMappingURL=AutoResizableComponent.js.map