import * as tslib_1 from "tslib";
import { autobind, BaseComponent } from "OfficeFabric/Utilities";
var BaseFluxComponent = (function (_super) {
    tslib_1.__extends(BaseFluxComponent, _super);
    function BaseFluxComponent(props, context) {
        var _this = _super.call(this, props, context) || this;
        _this.initializeState();
        return _this;
    }
    BaseFluxComponent.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        for (var _i = 0, _a = this.getStores(); _i < _a.length; _i++) {
            var store = _a[_i];
            store.addChangedListener(this._onStoreChanged);
        }
    };
    BaseFluxComponent.prototype.componentWillUnmount = function () {
        _super.prototype.componentWillUnmount.call(this);
        for (var _i = 0, _a = this.getStores(); _i < _a.length; _i++) {
            var store = _a[_i];
            store.removeChangedListener(this._onStoreChanged);
        }
    };
    BaseFluxComponent.prototype.getStores = function () {
        return [];
    };
    BaseFluxComponent.prototype.getStoresState = function () {
        return {};
    };
    BaseFluxComponent.prototype.initializeState = function () {
        this.state = {};
    };
    BaseFluxComponent.prototype._onStoreChanged = function () {
        var newStoreState = this.getStoresState();
        this.setState(newStoreState);
    };
    tslib_1.__decorate([
        autobind
    ], BaseFluxComponent.prototype, "_onStoreChanged", null);
    return BaseFluxComponent;
}(BaseComponent));
export { BaseFluxComponent };
//# sourceMappingURL=BaseFluxComponent.js.map