/// <reference types="react" />
import { BaseStore } from "../../../Flux/Stores/BaseStore";
import { ClassificationNodeKey } from "../../../Flux/Stores/ClassificationNodeStore";
import { BaseFluxComponent, IBaseFluxComponentState } from "../../Utilities/BaseFluxComponent";
import { ITreeComboProps } from "../../VssCombo/TreeCombo";
import { TreeNode } from "VSS/Controls/TreeView";
export interface IClassificationPickerProps extends ITreeComboProps {
    keyType: ClassificationNodeKey;
}
export interface IClassificationPickerState extends IBaseFluxComponentState {
    treeNode?: TreeNode;
    value?: string;
}
export declare class ClassificationPicker extends BaseFluxComponent<IClassificationPickerProps, IClassificationPickerState> {
    private _classificationNodeStore;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: IClassificationPickerProps, context?: any): void;
    render(): JSX.Element;
    protected getStoresState(): IClassificationPickerState;
    protected initializeState(): void;
    protected getStores(): BaseStore<any, any, any>[];
    private _initializeNodes(keyType);
    private _getTreeNode(node, uiNode, level);
    private _onChange(value);
    private _getDefaultError();
}
