import * as tslib_1 from "tslib";
import * as React from "react";
import { TeamActions } from "../../../Flux/Actions/TeamActions";
import { StoreFactory } from "../../../Flux/Stores/BaseStore";
import { TeamStore } from "../../../Flux/Stores/TeamStore";
import { BaseFluxComponent } from "../../Utilities/BaseFluxComponent";
import { SimpleCombo } from "../../VssCombo/SimpleCombo";
import { Spinner, SpinnerSize } from "OfficeFabric/Spinner";
import { css } from "OfficeFabric/Utilities";
var TeamPicker = (function (_super) {
    tslib_1.__extends(TeamPicker, _super);
    function TeamPicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._teamStore = StoreFactory.getInstance(TeamStore);
        return _this;
    }
    TeamPicker.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (this._teamStore.isLoaded()) {
            this.setState({
                allTeams: this._teamStore.getAll()
            });
        }
        else {
            TeamActions.initializeTeams();
        }
    };
    TeamPicker.prototype.render = function () {
        if (!this.state.allTeams) {
            return React.createElement(Spinner, { size: SpinnerSize.large });
        }
        var props = tslib_1.__assign({}, this.props, { className: css("team-picker", this.props.className), getItemText: function (team) { return team.name; }, options: this.state.allTeams, limitedToAllowedOptions: true });
        return React.createElement(SimpleCombo, tslib_1.__assign({}, props));
    };
    TeamPicker.prototype.getStores = function () {
        return [this._teamStore];
    };
    TeamPicker.prototype.getStoresState = function () {
        return {
            allTeams: this._teamStore.getAll()
        };
    };
    return TeamPicker;
}(BaseFluxComponent));
export { TeamPicker };
//# sourceMappingURL=TeamPicker.js.map