/// <reference types="react" />
import { BaseStore } from "../../../Flux/Stores/BaseStore";
import { BaseFluxComponent, IBaseFluxComponentState } from "../../Utilities/BaseFluxComponent";
import { ISimpleComboProps } from "../../VssCombo/SimpleCombo";
import { FieldType, WorkItemField } from "TFS/WorkItemTracking/Contracts";
export interface IWorkItemFieldPickerProps extends ISimpleComboProps<WorkItemField> {
    allowedFieldTypes?: FieldType[];
    workItemType?: string;
    excludeFields?: string[];
}
export interface IWorkItemFieldPickerState extends IBaseFluxComponentState {
    allowedFields?: WorkItemField[];
}
export declare class WorkItemFieldPicker extends BaseFluxComponent<IWorkItemFieldPickerProps, IWorkItemFieldPickerState> {
    private _fieldStore;
    private _workItemTypeStore;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: IWorkItemFieldPickerProps, context?: any): void;
    render(): JSX.Element;
    protected getStores(): BaseStore<any, any, any>[];
    protected getStoresState(): IWorkItemFieldPickerState;
    private _getAllowedFields(allowedFieldTypes, excludeFields, workItemType);
}
