/// <reference types="react" />
import { BaseStore } from "../../../Flux/Stores/BaseStore";
import { BaseFluxComponent, IBaseFluxComponentProps, IBaseFluxComponentState } from "../../Utilities/BaseFluxComponent";
import { WorkItemField } from "TFS/WorkItemTracking/Contracts";
export interface IWorkItemFieldValuePickerProps extends IBaseFluxComponentProps {
    field: WorkItemField;
    workItemType: string;
    value?: any;
    label?: string;
    delay?: number;
    info?: string;
    error?: string;
    required?: boolean;
    disabled?: boolean;
    onChange(value: any): void;
}
export interface IWorkItemFieldValuePickerState extends IBaseFluxComponentState {
    allowedValues?: string[];
}
export declare class WorkItemFieldValuePicker extends BaseFluxComponent<IWorkItemFieldValuePickerProps, IWorkItemFieldValuePickerState> {
    private static FieldTypesSupportingAllowedValues;
    private _fieldAllowedValuesStore;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: IWorkItemFieldValuePickerProps, context?: any): void;
    render(): JSX.Element;
    protected initializeState(): void;
    protected getStoresState(): IWorkItemFieldValuePickerState;
    protected getStores(): BaseStore<any, any, any>[];
    private _fieldSupportsAllowedValues(field);
    private _onCheckboxChange(_ev, checked?);
    private _onFieldValueChange(value);
    private _onTagsChange(tags);
}
