import * as tslib_1 from "tslib";
import * as React from "react";
import { WorkItemRelationTypeActions } from "../../../Flux/Actions/WorkItemRelationTypeActions";
import { StoreFactory } from "../../../Flux/Stores/BaseStore";
import { WorkItemRelationTypeStore } from "../../../Flux/Stores/WorkItemRelationTypeStore";
import { BaseFluxComponent } from "../../Utilities/BaseFluxComponent";
import { SimpleCombo } from "../../VssCombo/SimpleCombo";
import { Spinner, SpinnerSize } from "OfficeFabric/Spinner";
import { css } from "OfficeFabric/Utilities";
var WorkItemRelationTypePicker = (function (_super) {
    tslib_1.__extends(WorkItemRelationTypePicker, _super);
    function WorkItemRelationTypePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._workItemRelationTypeStore = StoreFactory.getInstance(WorkItemRelationTypeStore);
        return _this;
    }
    WorkItemRelationTypePicker.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (this._workItemRelationTypeStore.isLoaded()) {
            this.setState({
                relationTypes: this._workItemRelationTypeStore.getAll()
            });
        }
        else {
            WorkItemRelationTypeActions.initializeWorkItemRelationTypes();
        }
    };
    WorkItemRelationTypePicker.prototype.render = function () {
        if (!this.state.relationTypes) {
            return React.createElement(Spinner, { size: SpinnerSize.large });
        }
        var props = tslib_1.__assign({}, this.props, { className: css("work-item-relation-type-picker", this.props.className), getItemText: function (relationType) { return relationType.name; }, options: this.state.relationTypes, limitedToAllowedOptions: true });
        return React.createElement(SimpleCombo, tslib_1.__assign({}, props));
    };
    WorkItemRelationTypePicker.prototype.getStoresState = function () {
        return {
            relationTypes: this._workItemRelationTypeStore.getAll()
        };
    };
    WorkItemRelationTypePicker.prototype.getStores = function () {
        return [this._workItemRelationTypeStore];
    };
    return WorkItemRelationTypePicker;
}(BaseFluxComponent));
export { WorkItemRelationTypePicker };
//# sourceMappingURL=WorkItemRelationTypePicker.js.map