import * as tslib_1 from "tslib";
import "./WorkItemTitleView.css";
import * as React from "react";
import { WorkItemTypeActions } from "../../../Flux/Actions/WorkItemTypeActions";
import { StoreFactory } from "../../../Flux/Stores/BaseStore";
import { WorkItemTypeStore } from "../../../Flux/Stores/WorkItemTypeStore";
import { stringEquals } from "../../../Utilities/String";
import { BaseFluxComponent } from "../../Utilities/BaseFluxComponent";
import { Link } from "OfficeFabric/Link";
import { autobind, css } from "OfficeFabric/Utilities";
var WorkItemTitleView = (function (_super) {
    tslib_1.__extends(WorkItemTitleView, _super);
    function WorkItemTitleView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._workItemTypeStore = StoreFactory.getInstance(WorkItemTypeStore);
        return _this;
    }
    WorkItemTitleView.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (this._workItemTypeStore.isLoaded()) {
            this.setState({
                workItemType: this._workItemTypeStore.getItem(this.props.workItemType)
            });
        }
        else {
            WorkItemTypeActions.initializeWorkItemTypes();
        }
    };
    WorkItemTitleView.prototype.componentWillReceiveProps = function (nextProps, context) {
        _super.prototype.componentWillReceiveProps.call(this, nextProps, context);
        if (!stringEquals(nextProps.workItemType, this.props.workItemType, true)) {
            if (this._workItemTypeStore.isLoaded()) {
                this.setState({
                    workItemType: this._workItemTypeStore.getItem(nextProps.workItemType)
                });
            }
        }
    };
    WorkItemTitleView.prototype.render = function () {
        var wit = this.state.workItemType;
        var witColor = wit ? wit.color : null;
        var witIcon = wit ? wit.icon : null;
        var witIconUrl = (witIcon && witIcon.id) ? witIcon.url : null;
        if (witColor) {
            witColor = "#" + witColor.substring(witColor.length - 6);
        }
        else {
            witColor = "#000000";
        }
        var webContext = VSS.getWebContext();
        var witUrl = webContext.collection.uri + "/" + webContext.project.name + "/_workitems/edit/" + this.props.workItemId;
        return (React.createElement("div", { className: css("work-item-title-view", this.props.className) + " " + ((witIconUrl || !wit) ? "no-color" : ""), style: (witIconUrl || !wit) ? undefined : { borderColor: witColor } },
            witIconUrl && React.createElement("img", { src: witIconUrl, alt: "icon" }),
            this.props.showId && React.createElement("span", { className: "work-item-id" }, this.props.workItemId),
            React.createElement(Link, { className: "title-link", href: witUrl, onClick: this._onLinkClick }, this.props.title)));
    };
    WorkItemTitleView.prototype.initializeState = function () {
        this.state = { workItemType: null };
    };
    WorkItemTitleView.prototype.getStores = function () {
        return [this._workItemTypeStore];
    };
    WorkItemTitleView.prototype.getStoresState = function () {
        return {
            workItemType: this._workItemTypeStore.isLoaded() ? this._workItemTypeStore.getItem(this.props.workItemType) : null
        };
    };
    WorkItemTitleView.prototype._onLinkClick = function (e) {
        if (this.props.onClick && !e.ctrlKey) {
            e.preventDefault();
            this.props.onClick(e);
        }
    };
    tslib_1.__decorate([
        autobind
    ], WorkItemTitleView.prototype, "_onLinkClick", null);
    return WorkItemTitleView;
}(BaseFluxComponent));
export { WorkItemTitleView };
//# sourceMappingURL=WorkItemTitleView.js.map