import * as tslib_1 from "tslib";
import * as React from "react";
import { WorkItemTypeActions } from "../../../Flux/Actions/WorkItemTypeActions";
import { StoreFactory } from "../../../Flux/Stores/BaseStore";
import { WorkItemTypeStore } from "../../../Flux/Stores/WorkItemTypeStore";
import { BaseFluxComponent } from "../../Utilities/BaseFluxComponent";
import { SimpleCombo } from "../../VssCombo/SimpleCombo";
import { Spinner, SpinnerSize } from "OfficeFabric/Spinner";
import { css } from "OfficeFabric/Utilities";
var WorkItemTypePicker = (function (_super) {
    tslib_1.__extends(WorkItemTypePicker, _super);
    function WorkItemTypePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._workItemTypeStore = StoreFactory.getInstance(WorkItemTypeStore);
        return _this;
    }
    WorkItemTypePicker.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (this._workItemTypeStore.isLoaded()) {
            this.setState({
                allWits: this._workItemTypeStore.getAll()
            });
        }
        else {
            WorkItemTypeActions.initializeWorkItemTypes();
        }
    };
    WorkItemTypePicker.prototype.render = function () {
        if (!this.state.allWits) {
            return React.createElement(Spinner, { size: SpinnerSize.large });
        }
        var props = tslib_1.__assign({}, this.props, { className: css("work-item-type-picker", this.props.className), getItemText: function (wit) { return wit.name; }, options: this.state.allWits, limitedToAllowedOptions: true });
        return React.createElement(SimpleCombo, tslib_1.__assign({}, props));
    };
    WorkItemTypePicker.prototype.getStoresState = function () {
        return {
            allWits: this._workItemTypeStore.getAll()
        };
    };
    WorkItemTypePicker.prototype.getStores = function () {
        return [this._workItemTypeStore];
    };
    return WorkItemTypePicker;
}(BaseFluxComponent));
export { WorkItemTypePicker };
//# sourceMappingURL=WorkItemTypePicker.js.map