/// <reference types="react" />
import "./VssCombo.css";
import { IFocussable } from "../Interfaces";
import { BaseFluxComponent, IBaseFluxComponentProps, IBaseFluxComponentState } from "../Utilities/BaseFluxComponent";
export interface IDatePickerComboProps extends IBaseFluxComponentProps {
    value?: string;
    error?: string;
    label?: string;
    info?: string;
    disabled?: boolean;
    required?: boolean;
    delay?: number;
    onChange(value: string): void;
}
export interface IDatePickerComboState extends IBaseFluxComponentState {
    value?: string;
}
export declare class DatePickerCombo extends BaseFluxComponent<IDatePickerComboProps, IDatePickerComboState> implements IFocussable {
    private _control;
    private _delayedFunction;
    private _container;
    focus(): void;
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentWillReceiveProps(nextProps: IDatePickerComboProps, context?: any): void;
    protected initializeState(): void;
    private _dispose();
    private _getDefaultError();
    private _onChange();
    private _disposeDelayedFunction();
    private _containerRefCallback;
}
