/// <reference types="react" />
import "./VssCombo.css";
import { IFocussable } from "../Interfaces";
import { BaseFluxComponent, IBaseFluxComponentProps, IBaseFluxComponentState } from "../Utilities/BaseFluxComponent";
export interface ISimpleComboProps<T> extends IBaseFluxComponentProps {
    options?: T[];
    selectedOption?: T;
    selectedValue?: string;
    error?: string;
    label?: string;
    info?: string;
    disabled?: boolean;
    required?: boolean;
    delay?: number;
    limitedToAllowedOptions?: boolean;
    onChange(option: T, value?: string): void;
    getItemText?(option: T): string;
}
export interface ISimpleComboState<T> extends IBaseFluxComponentState {
    selectedOption?: T;
    selectedValue?: string;
}
export declare class SimpleCombo<T> extends BaseFluxComponent<ISimpleComboProps<T>, ISimpleComboState<T>> implements IFocussable {
    private _control;
    private _delayedFunction;
    private _nameToOptionMap;
    private _container;
    focus(): void;
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentWillReceiveProps(nextProps: ISimpleComboProps<T>, context?: any): void;
    protected initializeState(): void;
    private _buildOptionsMap(options, getItemText?);
    private _dispose();
    private _getTextValue(option, value?, getItemText?);
    private _getDefaultError();
    private _isSelectedValueValid(value);
    private _onChange();
    private _disposeDelayedFunction();
    private _containerRefCallback;
}
