/// <reference types="react" />
import "./VssCombo.css";
import { IFocussable } from "../Interfaces";
import { BaseFluxComponent, IBaseFluxComponentProps, IBaseFluxComponentState } from "../Utilities/BaseFluxComponent";
import { TreeNode } from "VSS/Controls/TreeView";
export interface ITreeComboProps extends IBaseFluxComponentProps {
    options?: TreeNode[];
    value?: string;
    error?: string;
    label?: string;
    info?: string;
    disabled?: boolean;
    required?: boolean;
    delay?: number;
    onChange(newValue: string): void;
}
export interface ITreeComboState extends IBaseFluxComponentState {
    value?: string;
}
export declare class TreeCombo extends BaseFluxComponent<ITreeComboProps, ITreeComboState> implements IFocussable {
    private _control;
    private _delayedFunction;
    private _container;
    focus(): void;
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentWillReceiveProps(nextProps: ITreeComboProps, context?: any): void;
    protected initializeState(): void;
    private _dispose();
    private _getDefaultError();
    private _onChange();
    private _disposeDelayedFunction();
    private _containerRefCallback;
}
