import * as tslib_1 from "tslib";
import { Observable } from "VSSUI/Utilities/Observable";
var Action = (function (_super) {
    tslib_1.__extends(Action, _super);
    function Action() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Action.prototype.invoke = function (payload) {
        if (Action.executing) {
            throw new Error("Cannot invoke an action from inside another action.");
        }
        Action.executing = true;
        try {
            this.notify(payload, null);
        }
        finally {
            Action.executing = false;
        }
    };
    Action.prototype.addListener = function (listener) {
        this.subscribe(listener);
    };
    Action.prototype.removeListener = function (listener) {
        this.unsubscribe(listener);
    };
    Action.executing = false;
    return Action;
}(Observable));
export { Action };
//# sourceMappingURL=Action.js.map