import * as tslib_1 from "tslib";
import { StoreFactory } from "../Stores/BaseStore";
import { ClassificationNodeKey, ClassificationNodeStore } from "../Stores/ClassificationNodeStore";
import { ClassificationNodeActionsHub } from "./ActionsHub";
import { TreeStructureGroup } from "TFS/WorkItemTracking/Contracts";
import * as WitClient from "TFS/WorkItemTracking/RestClient";
export var ClassificationNodeActions;
(function (ClassificationNodeActions) {
    var classificationNodeStore = StoreFactory.getInstance(ClassificationNodeStore);
    function initializeAreaPaths() {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var rootNode, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!classificationNodeStore.isLoaded(ClassificationNodeKey.Area)) return [3, 1];
                        ClassificationNodeActionsHub.InitializeAreaPaths.invoke(null);
                        return [3, 5];
                    case 1:
                        if (!!classificationNodeStore.isLoading(ClassificationNodeKey.Area)) return [3, 5];
                        classificationNodeStore.setLoading(true, ClassificationNodeKey.Area);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4, WitClient.getClient().getClassificationNode(VSS.getWebContext().project.id, TreeStructureGroup.Areas, null, 5)];
                    case 3:
                        rootNode = _a.sent();
                        ClassificationNodeActionsHub.InitializeAreaPaths.invoke(rootNode);
                        classificationNodeStore.setLoading(false, ClassificationNodeKey.Area);
                        return [3, 5];
                    case 4:
                        e_1 = _a.sent();
                        classificationNodeStore.setLoading(false, ClassificationNodeKey.Area);
                        throw e_1.message;
                    case 5: return [2];
                }
            });
        });
    }
    ClassificationNodeActions.initializeAreaPaths = initializeAreaPaths;
    function initializeIterationPaths() {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var rootNode, e_2;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!classificationNodeStore.isLoaded(ClassificationNodeKey.Iteration)) return [3, 1];
                        ClassificationNodeActionsHub.InitializeIterationPaths.invoke(null);
                        return [3, 5];
                    case 1:
                        if (!!classificationNodeStore.isLoading(ClassificationNodeKey.Iteration)) return [3, 5];
                        classificationNodeStore.setLoading(true, ClassificationNodeKey.Iteration);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4, WitClient.getClient()
                                .getClassificationNode(VSS.getWebContext().project.id, TreeStructureGroup.Iterations, null, 5)];
                    case 3:
                        rootNode = _a.sent();
                        ClassificationNodeActionsHub.InitializeIterationPaths.invoke(rootNode);
                        classificationNodeStore.setLoading(false, ClassificationNodeKey.Iteration);
                        return [3, 5];
                    case 4:
                        e_2 = _a.sent();
                        classificationNodeStore.setLoading(false, ClassificationNodeKey.Iteration);
                        throw e_2.message;
                    case 5: return [2];
                }
            });
        });
    }
    ClassificationNodeActions.initializeIterationPaths = initializeIterationPaths;
})(ClassificationNodeActions || (ClassificationNodeActions = {}));
//# sourceMappingURL=ClassificationNodeActions.js.map