import * as tslib_1 from "tslib";
import { localeIgnoreCaseComparer } from "../../Utilities/String";
import { StoreFactory } from "../Stores/BaseStore";
import { TeamStore } from "../Stores/TeamStore";
import { TeamActionsHub } from "./ActionsHub";
import * as CoreClient from "TFS/Core/RestClient";
export var TeamActions;
(function (TeamActions) {
    var teamStore = StoreFactory.getInstance(TeamStore);
    function initializeTeams() {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var teams, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!teamStore.isLoaded()) return [3, 1];
                        TeamActionsHub.InitializeTeams.invoke(null);
                        return [3, 5];
                    case 1:
                        if (!!teamStore.isLoading()) return [3, 5];
                        teamStore.setLoading(true);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4, getTeams()];
                    case 3:
                        teams = _a.sent();
                        teams.sort(function (a, b) { return localeIgnoreCaseComparer(a.name, b.name); });
                        TeamActionsHub.InitializeTeams.invoke(teams);
                        teamStore.setLoading(false);
                        return [3, 5];
                    case 4:
                        e_1 = _a.sent();
                        teamStore.setLoading(false);
                        throw e_1.message;
                    case 5: return [2];
                }
            });
        });
    }
    TeamActions.initializeTeams = initializeTeams;
    function getTeams() {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            var teams, top, client, project, getTeamDelegate;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        teams = [];
                        top = 300;
                        client = CoreClient.getClient();
                        project = VSS.getWebContext().project.id;
                        getTeamDelegate = function (skip) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                            var result;
                            return tslib_1.__generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, client.getTeams(project, top, skip)];
                                    case 1:
                                        result = _a.sent();
                                        if (result.length > 0) {
                                            teams.push.apply(teams, result);
                                        }
                                        if (!(result.length === top)) return [3, 3];
                                        return [4, getTeamDelegate(skip + top)];
                                    case 2:
                                        _a.sent();
                                        _a.label = 3;
                                    case 3: return [2];
                                }
                            });
                        }); };
                        return [4, getTeamDelegate(0)];
                    case 1:
                        _a.sent();
                        return [2, teams];
                }
            });
        });
    }
})(TeamActions || (TeamActions = {}));
//# sourceMappingURL=TeamActions.js.map