import * as tslib_1 from "tslib";
import { StoreFactory } from "../Stores/BaseStore";
import { TeamFieldStore } from "../Stores/TeamFieldStore";
import { TeamFieldActionsHub } from "./ActionsHub";
import * as WorkClient from "TFS/Work/RestClient";
export var TeamFieldActions;
(function (TeamFieldActions) {
    var teamFieldStore = StoreFactory.getInstance(TeamFieldStore);
    function initializeTeamFields(teamId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var teamContext, teamFieldValues, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!teamFieldStore.isLoaded(teamId)) return [3, 1];
                        TeamFieldActionsHub.InitializeTeamFieldItem.invoke(null);
                        return [3, 5];
                    case 1:
                        if (!!teamFieldStore.isLoading(teamId)) return [3, 5];
                        teamFieldStore.setLoading(true, teamId);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        teamContext = {
                            project: "",
                            projectId: VSS.getWebContext().project.id,
                            team: "",
                            teamId: teamId
                        };
                        return [4, WorkClient.getClient().getTeamFieldValues(teamContext)];
                    case 3:
                        teamFieldValues = _a.sent();
                        TeamFieldActionsHub.InitializeTeamFieldItem.invoke({ teamId: teamId, teamFieldValues: teamFieldValues });
                        teamFieldStore.setLoading(false, teamId);
                        return [3, 5];
                    case 4:
                        e_1 = _a.sent();
                        teamFieldStore.setLoading(false, teamId);
                        throw e_1.message;
                    case 5: return [2];
                }
            });
        });
    }
    TeamFieldActions.initializeTeamFields = initializeTeamFields;
})(TeamFieldActions || (TeamFieldActions = {}));
//# sourceMappingURL=TeamFieldActions.js.map