import * as tslib_1 from "tslib";
import { localeIgnoreCaseComparer } from "../../Utilities/String";
import { StoreFactory } from "../Stores/BaseStore";
import { WorkItemRelationTypeStore } from "../Stores/WorkItemRelationTypeStore";
import { WorkItemRelationTypeActionsHub } from "./ActionsHub";
import * as WitClient from "TFS/WorkItemTracking/RestClient";
export var WorkItemRelationTypeActions;
(function (WorkItemRelationTypeActions) {
    var workItemRelationTypeStore = StoreFactory.getInstance(WorkItemRelationTypeStore);
    function initializeWorkItemRelationTypes() {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var workItemRelationTypes, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!workItemRelationTypeStore.isLoaded()) return [3, 1];
                        WorkItemRelationTypeActionsHub.InitializeWorkItemRelationTypes.invoke(null);
                        return [3, 5];
                    case 1:
                        if (!!workItemRelationTypeStore.isLoading()) return [3, 5];
                        workItemRelationTypeStore.setLoading(true);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4, WitClient.getClient().getRelationTypes()];
                    case 3:
                        workItemRelationTypes = _a.sent();
                        workItemRelationTypes.sort(function (a, b) { return localeIgnoreCaseComparer(a.name, b.name); });
                        WorkItemRelationTypeActionsHub.InitializeWorkItemRelationTypes.invoke(workItemRelationTypes);
                        workItemRelationTypeStore.setLoading(false);
                        return [3, 5];
                    case 4:
                        e_1 = _a.sent();
                        workItemRelationTypeStore.setLoading(false);
                        throw e_1.message;
                    case 5: return [2];
                }
            });
        });
    }
    WorkItemRelationTypeActions.initializeWorkItemRelationTypes = initializeWorkItemRelationTypes;
})(WorkItemRelationTypeActions || (WorkItemRelationTypeActions = {}));
//# sourceMappingURL=WorkItemRelationTypeActions.js.map