import * as tslib_1 from "tslib";
import { localeIgnoreCaseComparer } from "../../Utilities/String";
import { StoreFactory } from "../Stores/BaseStore";
import { WorkItemTagStore } from "../Stores/WorkItemTagStore";
import { WorkItemTagActionsHub } from "./ActionsHub";
import * as Auth from "VSS/Authentication/Services";
export var WorkItemTagActions;
(function (WorkItemTagActions) {
    var tagsStore = StoreFactory.getInstance(WorkItemTagStore);
    function initializeTags() {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var tags, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!tagsStore.isLoaded()) return [3, 1];
                        WorkItemTagActionsHub.InitializeTags.invoke(null);
                        return [3, 5];
                    case 1:
                        if (!!tagsStore.isLoading()) return [3, 5];
                        tagsStore.setLoading(true);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4, getTags()];
                    case 3:
                        tags = _a.sent();
                        tags.sort(function (a, b) { return localeIgnoreCaseComparer(a.name, b.name); });
                        WorkItemTagActionsHub.InitializeTags.invoke(tags);
                        tagsStore.setLoading(false);
                        return [3, 5];
                    case 4:
                        e_1 = _a.sent();
                        WorkItemTagActionsHub.InitializeTags.invoke([]);
                        tagsStore.setLoading(false);
                        return [3, 5];
                    case 5: return [2];
                }
            });
        });
    }
    WorkItemTagActions.initializeTags = initializeTags;
    function getTags() {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var webContext, accessToken, authHeader, url, ajaxOptions, data;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        webContext = VSS.getWebContext();
                        return [4, VSS.getAccessToken()];
                    case 1:
                        accessToken = _a.sent();
                        authHeader = Auth.authTokenManager.getAuthorizationHeader(accessToken);
                        url = webContext.collection.uri + "/_apis/tagging/scopes/" + webContext.project.id + "/tags";
                        ajaxOptions = {
                            url: url,
                            method: "GET",
                            data: null,
                            beforeSend: function (req) {
                                req.setRequestHeader("Authorization", authHeader);
                                req.setRequestHeader("Accept", "application/json");
                            }
                        };
                        return [4, $.ajax(ajaxOptions)];
                    case 2:
                        data = _a.sent();
                        return [2, data.value];
                }
            });
        });
    }
})(WorkItemTagActions || (WorkItemTagActions = {}));
//# sourceMappingURL=WorkItemTagActions.js.map