import * as tslib_1 from "tslib";
import { StoreFactory } from "../Stores/BaseStore";
import { WorkItemTypeFieldAllowedValuesStore } from "../Stores/WorkItemTypeFieldAllowedValuesStore";
import { WorkItemTypeFieldAllowedValuesActionsHub } from "./ActionsHub";
import * as WitClient from "TFS/WorkItemTracking/RestClient";
import * as VSS_Service from "VSS/Service";
export var WorkItemTypeFieldAllowedValuesActions;
(function (WorkItemTypeFieldAllowedValuesActions) {
    var workItemTypeFieldStore = StoreFactory.getInstance(WorkItemTypeFieldAllowedValuesStore);
    function initializeAllowedValues(workItemType, fieldRefName) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var key, client, workItemTypeField, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = workItemType + "_" + fieldRefName;
                        if (!workItemTypeFieldStore.isLoaded(key)) return [3, 1];
                        WorkItemTypeFieldAllowedValuesActionsHub.InitializeAllowedValues.invoke(null);
                        return [3, 6];
                    case 1:
                        if (!!workItemTypeFieldStore.isLoading(key)) return [3, 6];
                        workItemTypeFieldStore.setLoading(true, key);
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 6]);
                        return [4, VSS_Service.getClient(WitClient.WorkItemTrackingHttpClient4_1)];
                    case 3:
                        client = _a.sent();
                        return [4, client.getWorkItemTypeField(VSS.getWebContext().project.id, workItemType, fieldRefName, 1)];
                    case 4:
                        workItemTypeField = _a.sent();
                        WorkItemTypeFieldAllowedValuesActionsHub.InitializeAllowedValues.invoke({
                            workItemType: workItemType,
                            fieldRefName: fieldRefName,
                            allowedValues: workItemTypeField.allowedValues || []
                        });
                        workItemTypeFieldStore.setLoading(false, key);
                        return [3, 6];
                    case 5:
                        e_1 = _a.sent();
                        WorkItemTypeFieldAllowedValuesActionsHub.InitializeAllowedValues.invoke({
                            workItemType: workItemType,
                            fieldRefName: fieldRefName,
                            allowedValues: []
                        });
                        workItemTypeFieldStore.setLoading(false, key);
                        return [3, 6];
                    case 6: return [2];
                }
            });
        });
    }
    WorkItemTypeFieldAllowedValuesActions.initializeAllowedValues = initializeAllowedValues;
})(WorkItemTypeFieldAllowedValuesActions || (WorkItemTypeFieldAllowedValuesActions = {}));
//# sourceMappingURL=WorkItemTypeFieldAllowedValuesActions.js.map