import * as tslib_1 from "tslib";
import { ErrorMessageActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var ErrorMessageStore = (function (_super) {
    tslib_1.__extends(ErrorMessageStore, _super);
    function ErrorMessageStore() {
        var _this = _super.call(this) || this;
        _this.items = {};
        return _this;
    }
    ErrorMessageStore.prototype.getKey = function () {
        return "ErrorMessageStore";
    };
    ErrorMessageStore.prototype.getItem = function (key) {
        return this.items[key];
    };
    ErrorMessageStore.prototype.initializeActionListeners = function () {
        var _this = this;
        ErrorMessageActionsHub.PushErrorMessage.addListener(function (error) {
            _this.items[error.errorKey] = error.errorMessage;
            _this.emitChanged();
        });
        ErrorMessageActionsHub.DismissErrorMessage.addListener(function (errorKey) {
            delete _this.items[errorKey];
            _this.emitChanged();
        });
        ErrorMessageActionsHub.DismissAllErrorMessages.addListener(function () {
            _this.items = {};
            _this.emitChanged();
        });
    };
    ErrorMessageStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return ErrorMessageStore;
}(BaseStore));
export { ErrorMessageStore };
//# sourceMappingURL=ErrorMessageStore.js.map