import * as tslib_1 from "tslib";
import { GitRepoActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var GitRepoStore = (function (_super) {
    tslib_1.__extends(GitRepoStore, _super);
    function GitRepoStore() {
        var _this = _super.call(this) || this;
        _this._itemsIdMap = {};
        _this._itemsNameMap = {};
        return _this;
    }
    GitRepoStore.prototype.getItem = function (idOrName) {
        var key = (idOrName || "").toLowerCase();
        return this._itemsIdMap[key] || this._itemsNameMap[key];
    };
    GitRepoStore.prototype.getKey = function () {
        return "GitRepoStore";
    };
    GitRepoStore.prototype.initializeActionListeners = function () {
        var _this = this;
        GitRepoActionsHub.InitializeGitRepos.addListener(function (repos) {
            if (repos) {
                _this.items = repos;
                _this._itemsIdMap = {};
                _this._itemsNameMap = {};
                for (var _i = 0, _a = _this.items; _i < _a.length; _i++) {
                    var item = _a[_i];
                    _this._itemsIdMap[item.id.toLowerCase()] = item;
                    _this._itemsNameMap[item.name.toLowerCase()] = item;
                }
            }
            _this.emitChanged();
        });
    };
    GitRepoStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return GitRepoStore;
}(BaseStore));
export { GitRepoStore };
//# sourceMappingURL=GitRepoStore.js.map