import * as tslib_1 from "tslib";
import { TeamFieldActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var TeamFieldStore = (function (_super) {
    tslib_1.__extends(TeamFieldStore, _super);
    function TeamFieldStore() {
        var _this = _super.call(this) || this;
        _this.items = {};
        return _this;
    }
    TeamFieldStore.prototype.getItem = function (teamId) {
        return this.items[teamId.toLowerCase()] || null;
    };
    TeamFieldStore.prototype.getKey = function () {
        return "TeamFieldStore";
    };
    TeamFieldStore.prototype.initializeActionListeners = function () {
        var _this = this;
        TeamFieldActionsHub.InitializeTeamFieldItem.addListener(function (values) {
            if (values) {
                _this.items[values.teamId.toLowerCase()] = values.teamFieldValues;
            }
            _this.emitChanged();
        });
    };
    TeamFieldStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return TeamFieldStore;
}(BaseStore));
export { TeamFieldStore };
//# sourceMappingURL=TeamFieldStore.js.map