import * as tslib_1 from "tslib";
import { WorkItemFieldActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var WorkItemFieldStore = (function (_super) {
    tslib_1.__extends(WorkItemFieldStore, _super);
    function WorkItemFieldStore() {
        var _this = _super.call(this) || this;
        _this._itemsRefNameMap = {};
        _this._itemsNameMap = {};
        return _this;
    }
    WorkItemFieldStore.prototype.getItem = function (fieldRefName) {
        var key = (fieldRefName || "").toLowerCase();
        return this._itemsRefNameMap[key] || this._itemsNameMap[key];
    };
    WorkItemFieldStore.prototype.getKey = function () {
        return "WorkItemFieldStore";
    };
    WorkItemFieldStore.prototype.initializeActionListeners = function () {
        var _this = this;
        WorkItemFieldActionsHub.InitializeWorkItemFields.addListener(function (fields) {
            if (fields) {
                _this.items = fields;
                _this._itemsRefNameMap = {};
                _this._itemsNameMap = {};
                for (var _i = 0, _a = _this.items; _i < _a.length; _i++) {
                    var item = _a[_i];
                    _this._itemsRefNameMap[item.referenceName.toLowerCase()] = item;
                    _this._itemsNameMap[item.name.toLowerCase()] = item;
                }
            }
            _this.emitChanged();
        });
    };
    WorkItemFieldStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return WorkItemFieldStore;
}(BaseStore));
export { WorkItemFieldStore };
//# sourceMappingURL=WorkItemFieldStore.js.map