import * as tslib_1 from "tslib";
import { WorkItemRelationTypeActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var WorkItemRelationTypeStore = (function (_super) {
    tslib_1.__extends(WorkItemRelationTypeStore, _super);
    function WorkItemRelationTypeStore() {
        var _this = _super.call(this) || this;
        _this._itemsRefNameMap = {};
        _this._itemsNameMap = {};
        return _this;
    }
    WorkItemRelationTypeStore.prototype.getItem = function (relationTypeRefName) {
        var key = (relationTypeRefName || "").toLowerCase();
        return this._itemsRefNameMap[key] || this._itemsNameMap[key];
    };
    WorkItemRelationTypeStore.prototype.getKey = function () {
        return "WorkItemRelationTypeStore";
    };
    WorkItemRelationTypeStore.prototype.initializeActionListeners = function () {
        var _this = this;
        WorkItemRelationTypeActionsHub.InitializeWorkItemRelationTypes.addListener(function (workItemRelationTypes) {
            if (workItemRelationTypes) {
                _this.items = workItemRelationTypes;
                _this._itemsRefNameMap = {};
                _this._itemsNameMap = {};
                for (var _i = 0, _a = _this.items; _i < _a.length; _i++) {
                    var item = _a[_i];
                    _this._itemsRefNameMap[item.referenceName.toLowerCase()] = item;
                    _this._itemsNameMap[item.name.toLowerCase()] = item;
                }
            }
            _this.emitChanged();
        });
    };
    WorkItemRelationTypeStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return WorkItemRelationTypeStore;
}(BaseStore));
export { WorkItemRelationTypeStore };
//# sourceMappingURL=WorkItemRelationTypeStore.js.map