import * as tslib_1 from "tslib";
import { WorkItemTagActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var WorkItemTagStore = (function (_super) {
    tslib_1.__extends(WorkItemTagStore, _super);
    function WorkItemTagStore() {
        var _this = _super.call(this) || this;
        _this._itemsIdMap = {};
        _this._itemsNameMap = {};
        return _this;
    }
    WorkItemTagStore.prototype.getItem = function (idOrName) {
        var key = (idOrName || "").toLowerCase();
        return this._itemsIdMap[key] || this._itemsNameMap[key];
    };
    WorkItemTagStore.prototype.getKey = function () {
        return "WorkItemTagStore";
    };
    WorkItemTagStore.prototype.initializeActionListeners = function () {
        var _this = this;
        WorkItemTagActionsHub.InitializeTags.addListener(function (tags) {
            if (tags) {
                _this.items = tags;
                _this._itemsIdMap = {};
                _this._itemsNameMap = {};
                for (var _i = 0, _a = _this.items; _i < _a.length; _i++) {
                    var item = _a[_i];
                    _this._itemsIdMap[item.id.toLowerCase()] = item;
                    _this._itemsNameMap[item.name.toLowerCase()] = item;
                }
            }
            _this.emitChanged();
        });
    };
    WorkItemTagStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return WorkItemTagStore;
}(BaseStore));
export { WorkItemTagStore };
//# sourceMappingURL=WorkItemTagStore.js.map