import * as tslib_1 from "tslib";
import { WorkItemTemplateActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var WorkItemTemplateStore = (function (_super) {
    tslib_1.__extends(WorkItemTemplateStore, _super);
    function WorkItemTemplateStore() {
        var _this = _super.call(this) || this;
        _this.items = {};
        _this._itemsIdMap = {};
        return _this;
    }
    WorkItemTemplateStore.prototype.getItem = function (teamId) {
        var key = (teamId || "").toLowerCase();
        return this.items[key];
    };
    WorkItemTemplateStore.prototype.getTemplate = function (id) {
        var key = (id || "").toLowerCase();
        return this._itemsIdMap[key];
    };
    WorkItemTemplateStore.prototype.getKey = function () {
        return "WorkItemTemplateStore";
    };
    WorkItemTemplateStore.prototype.initializeActionListeners = function () {
        var _this = this;
        WorkItemTemplateActionsHub.InitializeWorkItemTemplates.addListener(function (data) {
            if (data && data.teamId && data.templates) {
                _this.items[data.teamId.toLowerCase()] = data.templates;
                for (var _i = 0, _a = data.templates; _i < _a.length; _i++) {
                    var template = _a[_i];
                    _this._itemsIdMap[template.id.toLowerCase()] = template;
                }
            }
            _this.emitChanged();
        });
    };
    WorkItemTemplateStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return WorkItemTemplateStore;
}(BaseStore));
export { WorkItemTemplateStore };
//# sourceMappingURL=WorkItemTemplateStore.js.map