import * as tslib_1 from "tslib";
import { WorkItemTypeFieldAllowedValuesActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var WorkItemTypeFieldAllowedValuesStore = (function (_super) {
    tslib_1.__extends(WorkItemTypeFieldAllowedValuesStore, _super);
    function WorkItemTypeFieldAllowedValuesStore() {
        var _this = _super.call(this) || this;
        _this.items = {};
        return _this;
    }
    WorkItemTypeFieldAllowedValuesStore.prototype.getItem = function (key) {
        return this.items[key.toLowerCase()];
    };
    WorkItemTypeFieldAllowedValuesStore.prototype.getAllowedValues = function (workItemType, fieldRefName) {
        var key = workItemType + "_" + fieldRefName;
        return this.items[key.toLowerCase()];
    };
    WorkItemTypeFieldAllowedValuesStore.prototype.getKey = function () {
        return "WorkItemTypeFieldAllowedValuesStore";
    };
    WorkItemTypeFieldAllowedValuesStore.prototype.initializeActionListeners = function () {
        var _this = this;
        WorkItemTypeFieldAllowedValuesActionsHub.InitializeAllowedValues.addListener(function (data) {
            if (data) {
                var key = data.workItemType + "_" + data.fieldRefName;
                _this.items[key.toLowerCase()] = data.allowedValues;
            }
            _this.emitChanged();
        });
    };
    WorkItemTypeFieldAllowedValuesStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return WorkItemTypeFieldAllowedValuesStore;
}(BaseStore));
export { WorkItemTypeFieldAllowedValuesStore };
//# sourceMappingURL=WorkItemTypeFieldAllowedValuesStore.js.map