import * as tslib_1 from "tslib";
import { WorkItemTypeActionsHub } from "../Actions/ActionsHub";
import { BaseStore } from "./BaseStore";
var WorkItemTypeStore = (function (_super) {
    tslib_1.__extends(WorkItemTypeStore, _super);
    function WorkItemTypeStore() {
        var _this = _super.call(this) || this;
        _this._itemsIdMap = {};
        return _this;
    }
    WorkItemTypeStore.prototype.getItem = function (typeName) {
        var key = (typeName || "").toLowerCase();
        return this._itemsIdMap[key];
    };
    WorkItemTypeStore.prototype.getKey = function () {
        return "WorkItemTypeStore";
    };
    WorkItemTypeStore.prototype.initializeActionListeners = function () {
        var _this = this;
        WorkItemTypeActionsHub.InitializeWorkItemTypes.addListener(function (workItemTypes) {
            if (workItemTypes) {
                _this.items = workItemTypes;
                _this._itemsIdMap = {};
                for (var _i = 0, _a = _this.items; _i < _a.length; _i++) {
                    var item = _a[_i];
                    _this._itemsIdMap[item.name.toLowerCase()] = item;
                }
            }
            _this.emitChanged();
        });
    };
    WorkItemTypeStore.prototype.convertItemKeyToString = function (key) {
        return key;
    };
    return WorkItemTypeStore;
}(BaseStore));
export { WorkItemTypeStore };
//# sourceMappingURL=WorkItemTypeStore.js.map