export declare function delegate(instance: any, method: Function, data?: any): (...args: any[]) => any;
export declare class DelayedFunction {
    private _interval;
    private _func;
    private _timeoutHandle;
    constructor(instance: any, ms: number, method: Function, data?: any[]);
    dispose(): void;
    start(): void;
    reset(): void;
    cancel(): void;
    invokeNow(): void;
    isPending(): boolean;
    private _invoke();
}
export declare function delay(instance: any, ms: number, method: Function, data?: any[]): DelayedFunction;
export declare function throttledDelegate(instance: any, ms: number, method: Function, data?: any[]): (...args: any[]) => any;
export declare function confirmAction(condition: boolean, msg: string): Promise<boolean>;
export declare function showErrorDialog(message: string, reason?: any): Promise<void>;
