export declare function readDocuments<T>(key: string, isPrivate?: boolean): Promise<T[]>;
export declare function readDocument<T>(key: string, id: string, defaultValue?: T, isPrivate?: boolean): Promise<T>;
export declare function createDocument<T>(key: string, data: T, isPrivate?: boolean): Promise<T>;
export declare function updateDocument<T>(key: string, data: T, isPrivate?: boolean): Promise<T>;
export declare function addOrUpdateDocument<T>(key: string, data: T, isPrivate?: boolean): Promise<T>;
export declare function deleteDocument(key: string, id: string, isPrivate?: boolean): Promise<void>;
export declare function readSetting<T>(key: string, defaultValue?: T, isPrivate?: boolean): Promise<T>;
export declare function writeSetting<T>(key: string, data: T, isPrivate?: boolean): Promise<T>;
export declare function queryCollectionNames(collectionNames: string[]): Promise<ExtensionDataCollection[]>;
export declare function queryCollections(collections: ExtensionDataCollection[]): Promise<ExtensionDataCollection[]>;
