import * as tslib_1 from "tslib";
var extensionDataService;
function getDataService() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!extensionDataService) return [3, 2];
                    return [4, VSS.getService(VSS.ServiceIds.ExtensionData)];
                case 1:
                    extensionDataService = _a.sent();
                    _a.label = 2;
                case 2: return [2, extensionDataService];
            }
        });
    });
}
export function readDocuments(key, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService, data, e_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4, dataService.getDocuments(key, isPrivate ? { scopeType: "User" } : undefined)];
                case 3:
                    data = _a.sent();
                    return [3, 5];
                case 4:
                    e_1 = _a.sent();
                    data = [];
                    return [3, 5];
                case 5: return [2, data];
            }
        });
    });
}
export function readDocument(key, id, defaultValue, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService, data, e_2;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4, dataService.getDocument(key, id, isPrivate ? { scopeType: "User" } : undefined)];
                case 3:
                    data = _a.sent();
                    return [3, 5];
                case 4:
                    e_2 = _a.sent();
                    data = defaultValue;
                    return [3, 5];
                case 5: return [2, data];
            }
        });
    });
}
export function createDocument(key, data, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    return [4, dataService.createDocument(key, data, isPrivate ? { scopeType: "User" } : undefined)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function updateDocument(key, data, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    return [4, dataService.updateDocument(key, data, isPrivate ? { scopeType: "User" } : undefined)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function addOrUpdateDocument(key, data, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    return [4, dataService.setDocument(key, data, isPrivate ? { scopeType: "User" } : undefined)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function deleteDocument(key, id, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    return [4, dataService.deleteDocument(key, id, isPrivate ? { scopeType: "User" } : undefined)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function readSetting(key, defaultValue, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService, data, e_3;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4, dataService.getValue(key, isPrivate ? { scopeType: "User" } : undefined)];
                case 3:
                    data = _a.sent();
                    return [2, data == null ? defaultValue : data];
                case 4:
                    e_3 = _a.sent();
                    return [2, defaultValue];
                case 5: return [2];
            }
        });
    });
}
export function writeSetting(key, data, isPrivate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    return [4, dataService.setValue(key, data, isPrivate ? { scopeType: "User" } : undefined)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function queryCollectionNames(collectionNames) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    return [4, dataService.queryCollectionNames(collectionNames)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function queryCollections(collections) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dataService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDataService()];
                case 1:
                    dataService = _a.sent();
                    return [4, dataService.queryCollections(collections)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
//# sourceMappingURL=ExtensionDataManager.js.map