import * as tslib_1 from "tslib";
var navigationService;
function getNavigationService() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!navigationService) return [3, 2];
                    return [4, VSS.getService(VSS.ServiceIds.Navigation)];
                case 1:
                    navigationService = (_a.sent());
                    _a.label = 2;
                case 2: return [2, navigationService];
            }
        });
    });
}
export function navigate(data, replaceHistoryEntry, mergeWithCurrentState, windowTitle, suppressNavigate) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var navService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getNavigationService()];
                case 1:
                    navService = _a.sent();
                    navService.updateHistoryEntry(null, data, replaceHistoryEntry, mergeWithCurrentState, windowTitle, suppressNavigate);
                    return [2];
            }
        });
    });
}
export function getQueryUrl(workItems, fields) {
    var _a = VSS.getWebContext(), collection = _a.collection, project = _a.project;
    var fieldStr = fields.join(",");
    var ids = (workItems).map(function (w) { return w.id; }).join(",");
    var wiql = "SELECT " + fieldStr + "\n                FROM WorkItems\n                WHERE [System.ID] IN (" + ids + ")";
    return collection.uri + "/" + project.name + "/_queries/query/?wiql=" + encodeURIComponent(wiql);
}
export function getWorkItemUrl(workItemId) {
    var _a = VSS.getWebContext(), collection = _a.collection, project = _a.project;
    return collection.uri + "/" + project.name + "/_workitems/edit/" + workItemId;
}
//# sourceMappingURL=Navigation.js.map