import * as tslib_1 from "tslib";
import { first } from "./Array";
import { stringEquals } from "./String";
import { WorkItemFormNavigationService, WorkItemFormService } from "TFS/WorkItemTracking/Services";
var workItemFormService;
function getFormService() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!workItemFormService) return [3, 2];
                    return [4, WorkItemFormService.getService()];
                case 1:
                    workItemFormService = _a.sent();
                    _a.label = 2;
                case 2: return [2, workItemFormService];
            }
        });
    });
}
export function openWorkItemDialog(e, item) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var newTab, workItemNavSvc;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    newTab = e ? e.ctrlKey : false;
                    return [4, WorkItemFormNavigationService.getService()];
                case 1:
                    workItemNavSvc = _a.sent();
                    return [4, workItemNavSvc.openWorkItem(item.id, newTab)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function getWorkItemAllowedFieldValues(fieldRefName) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var formService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getFormService()];
                case 1:
                    formService = _a.sent();
                    return [4, formService.getAllowedFieldValues(fieldRefName)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function getWorkItemFieldValue(fieldName) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var formService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getFormService()];
                case 1:
                    formService = _a.sent();
                    return [4, formService.getFieldValue(fieldName)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function getWorkItemFieldValues(fieldNames) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var formService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getFormService()];
                case 1:
                    formService = _a.sent();
                    return [4, formService.getFieldValues(fieldNames)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function getWorkItemFields() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var formService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getFormService()];
                case 1:
                    formService = _a.sent();
                    return [4, formService.getFields()];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function getWorkItemField(fieldName) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var fields, field;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getWorkItemFields()];
                case 1:
                    fields = _a.sent();
                    field = first(fields, function (f) {
                        return stringEquals(f.name, fieldName, true) || stringEquals(f.referenceName, fieldName, true);
                    });
                    if (field) {
                        return [2, field];
                    }
                    else {
                        throw "Field '" + fieldName + "' does not exist in this work item type";
                    }
                    return [2];
            }
        });
    });
}
export function setWorkItemFieldValue(fieldRefName, value) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var formService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getFormService()];
                case 1:
                    formService = _a.sent();
                    return [4, formService.setFieldValue(fieldRefName, value)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function setWorkItemFieldValues(fieldToValueMap) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var formService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getFormService()];
                case 1:
                    formService = _a.sent();
                    return [4, formService.setFieldValues(fieldToValueMap)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
export function saveWorkItem(successCallback, errorCallback) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var formService;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getFormService()];
                case 1:
                    formService = _a.sent();
                    return [4, formService.beginSaveWorkItem(successCallback, errorCallback)];
                case 2: return [2, _a.sent()];
            }
        });
    });
}
//# sourceMappingURL=WorkItemFormHelpers.js.map