/// <reference types="react" />
import "./ColorPicker.css";
import { BaseFluxComponent, IBaseFluxComponentProps, IBaseFluxComponentState } from "../Utilities/BaseFluxComponent";
export interface IColorPickerProps extends IBaseFluxComponentProps {
    selectedColor?: string;
    label?: string;
    info?: string;
    onChange(newColor: string): void;
}
export interface IColorPickerState extends IBaseFluxComponentState {
    selectedColor?: string;
    isCalloutOpen?: boolean;
}
export declare class ColorPicker extends BaseFluxComponent<IColorPickerProps, IColorPickerState> {
    private _targetElement;
    componentWillReceiveProps(nextProps: IColorPickerProps, context?: any): void;
    render(): JSX.Element;
    protected initializeState(): void;
    private _renderColorItem(color, index);
    private _selectColor(color);
    private _toggleCallout();
    private _onCalloutDismiss();
}
