/// <reference types="react" />
import "./SplitterLayout.css";
import * as React from "react";
export interface ISplitterLayoutProps {
    customClassName?: string;
    vertical?: boolean;
    percentage?: boolean;
    primaryIndex: number;
    primaryMinSize: number;
    secondaryInitialSize: number;
    secondaryMinSize: number;
    children: React.ReactNode[];
    onChange(secondaryPaneSize: number): void;
}
export interface ISplitterLayoutState {
    secondaryPaneSize: number;
    resizing: boolean;
}
export declare class SplitterLayout extends React.Component<ISplitterLayoutProps, ISplitterLayoutState> {
    private _splitterElement;
    private _containerElement;
    constructor(props: ISplitterLayoutProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private _getSecondaryPaneSize(containerRect, splitRect, clientPosition, offsetMouse);
    private _handleResize();
    private _handleMouseMove(e);
    private _handleSplitterMouseDown();
    private _handleMouseUp();
}
