/// <reference types="react" />
import * as React from "react";
export declare const VERTICAL = "VERTICAL";
export declare const HORIZONTAL = "HORIZONTAL";
export interface ISortableProps {
    className?: string;
    items: any[];
    sortId: number;
    moveInMiddle?: boolean;
    onSortEnd(): void;
    onSortItems(items: any[]): void;
}
export declare function sortable(Comp: any, flowDirection?: string): {
    new (props: ISortableProps, context?: any): {
        render(): JSX.Element;
        sortEnd: (e: DragEvent) => void;
        sortStart: (e: any) => void;
        dragOver: (e: any) => void;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: ISortableProps) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callBack?: () => void): void;
        props: Readonly<{
            children?: React.ReactNode;
        }> & Readonly<ISortableProps>;
        state: Readonly<{}>;
        context: any;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentWillMount?(): void;
        componentDidMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<ISortableProps>, nextContext: any): void;
        shouldComponentUpdate?(nextProps: Readonly<ISortableProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUpdate?(nextProps: Readonly<ISortableProps>, nextState: Readonly<{}>, nextContext: any): void;
        componentDidUpdate?(prevProps: Readonly<ISortableProps>, prevState: Readonly<{}>, prevContext: any): void;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
    };
};
