/// <reference types="react" />
import "./ThrottledTextField.css";
import { IFocussable } from "../Interfaces";
import { BaseFluxComponent, IBaseFluxComponentState } from "./BaseFluxComponent";
import { ITextFieldProps } from "OfficeFabric/TextField";
export interface IThrottledTextFieldProps extends ITextFieldProps {
    delay?: number;
    info?: string;
    required?: boolean;
}
export interface IThrottledTextFieldState extends IBaseFluxComponentState {
    internalValue?: string;
}
export declare class ThrottledTextField extends BaseFluxComponent<IThrottledTextFieldProps, IThrottledTextFieldState> implements IFocussable {
    private _delayedFunction;
    private _component;
    focus(): void;
    render(): JSX.Element;
    componentWillUnmount(): void;
    componentWillReceiveProps(nextProps: IThrottledTextFieldProps, context?: any): void;
    protected initializeState(): void;
    private _refCallback(component);
    private _onChange(value);
    private _disposeDelayedFunction();
    private _getDefaultError();
}
