import { AutoResizableComponent } from "../../Utilities/AutoResizableComponent";
import { IBaseFluxComponentProps, IBaseFluxComponentState } from "../../Utilities/BaseFluxComponent";
export interface IFieldControlProps extends IBaseFluxComponentProps {
    fieldName: string;
}
export interface IFieldControlState extends IBaseFluxComponentState {
    error?: string;
    value?: any;
}
export declare abstract class FieldControl<TP extends IFieldControlProps, TS extends IFieldControlState> extends AutoResizableComponent<TP, TS> {
    static getInputs<T>(): T;
    private _flushing;
    componentDidMount(): void;
    componentWillUnmount(): void;
    protected onValueChanged(newValue: any): Promise<void>;
    protected getErrorMessage(_value: string): string;
    private _invalidate();
    private _getCurrentFieldValue();
    private _setValue(value);
    private _onError(error);
}
