/// <reference types="react" />
import "./WorkItemTagPicker.css";
import { BaseStore } from "../../../Flux/Stores/BaseStore";
import { BaseFluxComponent, IBaseFluxComponentProps, IBaseFluxComponentState } from "../../Utilities/BaseFluxComponent";
import { WebApiTagDefinition } from "TFS/Core/Contracts";
export interface IWorkItemTagPickerProps extends IBaseFluxComponentProps {
    selectedTags?: string[];
    error?: string;
    label?: string;
    info?: string;
    disabled?: boolean;
    required?: boolean;
    onChange?(tags: string[]): void;
}
export interface IWorkItemTagPickerState extends IBaseFluxComponentState {
    allTags?: WebApiTagDefinition[];
    selectedTags?: string[];
}
export declare class WorkItemTagPicker extends BaseFluxComponent<IWorkItemTagPickerProps, IWorkItemTagPickerState> {
    private _workItemTagStore;
    componentDidMount(): void;
    render(): JSX.Element;
    protected getStoresState(): IWorkItemTagPickerState;
    protected getStores(): BaseStore<any, any, any>[];
    protected initializeState(): void;
    private _getDefaultError();
    private _onChange(items);
    private _getTag(tag);
    private _getTagText(tag);
    private _onTagFilterChanged(filterText, tagList);
}
