import { Action } from "./Action";
import { WebApiTagDefinition, WebApiTeam } from "TFS/Core/Contracts";
import { GitRepository } from "TFS/VersionControl/Contracts";
import { TeamFieldValues } from "TFS/Work/Contracts";
import { WorkItem, WorkItemClassificationNode, WorkItemField, WorkItemRelationType, WorkItemStateColor, WorkItemTemplate, WorkItemTemplateReference, WorkItemType } from "TFS/WorkItemTracking/Contracts";
export declare namespace WorkItemTypeActionsHub {
    const InitializeWorkItemTypes: Action<WorkItemType[]>;
}
export declare namespace WorkItemRelationTypeActionsHub {
    const InitializeWorkItemRelationTypes: Action<WorkItemRelationType[]>;
}
export declare namespace WorkItemFieldActionsHub {
    const InitializeWorkItemFields: Action<WorkItemField[]>;
}
export declare namespace WorkItemTemplateActionsHub {
    const InitializeWorkItemTemplates: Action<{
        teamId: string;
        templates: WorkItemTemplateReference[];
    }>;
}
export declare namespace WorkItemTemplateItemActionsHub {
    const InitializeWorkItemTemplateItem: Action<WorkItemTemplate>;
}
export declare namespace WorkItemStateItemActionsHub {
    const InitializeWorkItemStateItems: Action<{
        witName: string;
        states: WorkItemStateColor[];
    }>;
}
export declare namespace TeamActionsHub {
    const InitializeTeams: Action<WebApiTeam[]>;
}
export declare namespace WorkItemTagActionsHub {
    const InitializeTags: Action<WebApiTagDefinition[]>;
}
export declare namespace GitRepoActionsHub {
    const InitializeGitRepos: Action<GitRepository[]>;
}
export declare namespace TeamFieldActionsHub {
    const InitializeTeamFieldItem: Action<{
        teamId: string;
        teamFieldValues: TeamFieldValues;
    }>;
}
export declare namespace WorkItemTypeFieldAllowedValuesActionsHub {
    const InitializeAllowedValues: Action<{
        workItemType: string;
        fieldRefName: string;
        allowedValues: string[];
    }>;
}
export declare namespace WorkItemActionsHub {
    const AddOrUpdateWorkItems: Action<WorkItem[]>;
    const DeleteWorkItems: Action<number[]>;
    const ClearWorkItems: Action<{}>;
}
export declare namespace ErrorMessageActionsHub {
    const PushErrorMessage: Action<{
        errorMessage: string;
        errorKey: string;
    }>;
    const DismissErrorMessage: Action<string>;
    const DismissAllErrorMessages: Action<void>;
}
export declare namespace ClassificationNodeActionsHub {
    const InitializeAreaPaths: Action<WorkItemClassificationNode>;
    const InitializeIterationPaths: Action<WorkItemClassificationNode>;
}
