import { BaseStore } from "./BaseStore";
import { WorkItemClassificationNode } from "TFS/WorkItemTracking/Contracts";
export interface IClassificationNodeItem {
    areaPathRoot: WorkItemClassificationNode;
    iterationPathRoot: WorkItemClassificationNode;
}
export declare enum ClassificationNodeKey {
    Area = "Area",
    Iteration = "Iteration",
}
export declare class ClassificationNodeStore extends BaseStore<IClassificationNodeItem, WorkItemClassificationNode, ClassificationNodeKey> {
    private _areaPathIdMap;
    private _areaPathMap;
    private _iterationPathIdMap;
    private _iterationPathMap;
    constructor();
    getItem(nodeKey: ClassificationNodeKey): WorkItemClassificationNode;
    getAreaPathNode(nodeIdOrPath: string): WorkItemClassificationNode;
    getIterationPathNode(nodeIdOrPath: string): WorkItemClassificationNode;
    getKey(): string;
    protected initializeActionListeners(): void;
    protected convertItemKeyToString(key: ClassificationNodeKey): string;
    private _populateNodeData(node, parentNodeName, nodeType);
}
